from pybindgen import Module, FileCodeSink, param, retval, cppclass, typehandlers

def register_types(module):
    root_module = module.get_root()
    
    ## loader-factory.h: ns3::Loader [class]
    module.add_class('Loader', allow_subclassing=True)
    ## task-manager.h: ns3::Task [class]
    module.add_class('Task', is_singleton=True)
    ## process-manager.h: ns3::ProcessManager [class]
    module.add_class('ProcessManager', parent=root_module['ns3::Object'])
    ## socket-fd-factory.h: ns3::SocketFdFactory [class]
    module.add_class('SocketFdFactory', parent=root_module['ns3::Object'])
    ## task-manager.h: ns3::TaskManager [class]
    module.add_class('TaskManager', parent=root_module['ns3::Object'])
    ## task-scheduler.h: ns3::TaskScheduler [class]
    module.add_class('TaskScheduler', parent=root_module['ns3::Object'])
    ## loader-factory.h: ns3::LoaderFactory [class]
    module.add_class('LoaderFactory', parent=root_module['ns3::Object'])
    
    ## Register a nested module for the namespace Config
    
    nested_module = module.add_cpp_namespace('Config')
    register_types_ns3_Config(nested_module)
    
    
    ## Register a nested module for the namespace TimeStepPrecision
    
    nested_module = module.add_cpp_namespace('TimeStepPrecision')
    register_types_ns3_TimeStepPrecision(nested_module)
    
    
    ## Register a nested module for the namespace addressUtils
    
    nested_module = module.add_cpp_namespace('addressUtils')
    register_types_ns3_addressUtils(nested_module)
    
    
    ## Register a nested module for the namespace aodv
    
    nested_module = module.add_cpp_namespace('aodv')
    register_types_ns3_aodv(nested_module)
    
    
    ## Register a nested module for the namespace dot11s
    
    nested_module = module.add_cpp_namespace('dot11s')
    register_types_ns3_dot11s(nested_module)
    
    
    ## Register a nested module for the namespace flame
    
    nested_module = module.add_cpp_namespace('flame')
    register_types_ns3_flame(nested_module)
    
    
    ## Register a nested module for the namespace internal
    
    nested_module = module.add_cpp_namespace('internal')
    register_types_ns3_internal(nested_module)
    
    
    ## Register a nested module for the namespace olsr
    
    nested_module = module.add_cpp_namespace('olsr')
    register_types_ns3_olsr(nested_module)
    

def register_types_ns3_Config(module):
    root_module = module.get_root()
    

def register_types_ns3_TimeStepPrecision(module):
    root_module = module.get_root()
    

def register_types_ns3_addressUtils(module):
    root_module = module.get_root()
    

def register_types_ns3_aodv(module):
    root_module = module.get_root()
    

def register_types_ns3_dot11s(module):
    root_module = module.get_root()
    

def register_types_ns3_flame(module):
    root_module = module.get_root()
    

def register_types_ns3_internal(module):
    root_module = module.get_root()
    

def register_types_ns3_olsr(module):
    root_module = module.get_root()
    

def register_methods(root_module):
    register_Ns3Loader_methods(root_module, root_module['ns3::Loader'])
    register_Ns3Task_methods(root_module, root_module['ns3::Task'])
    register_Ns3ProcessManager_methods(root_module, root_module['ns3::ProcessManager'])
    register_Ns3SocketFdFactory_methods(root_module, root_module['ns3::SocketFdFactory'])
    register_Ns3TaskManager_methods(root_module, root_module['ns3::TaskManager'])
    register_Ns3TaskScheduler_methods(root_module, root_module['ns3::TaskScheduler'])
    register_Ns3LoaderFactory_methods(root_module, root_module['ns3::LoaderFactory'])
    return

def register_Ns3Loader_methods(root_module, cls):
    ## loader-factory.h: ns3::Loader::Loader() [constructor]
    cls.add_constructor([])
    ## loader-factory.h: ns3::Loader::Loader(ns3::Loader const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Loader const &', 'arg0')])
    ## loader-factory.h: void ns3::Loader::AddOverride(std::string from, std::string to) [member function]
    cls.add_method('AddOverride', 
                   'void', 
                   [param('std::string', 'from'), param('std::string', 'to')], 
                   is_pure_virtual=True, is_virtual=True)
    ## loader-factory.h: void * ns3::Loader::Load(std::string filename, int flag) [member function]
    cls.add_method('Load', 
                   'void *', 
                   [param('std::string', 'filename'), param('int', 'flag')], 
                   is_pure_virtual=True, is_virtual=True)
    ## loader-factory.h: void * ns3::Loader::Lookup(void * module, std::string symbol) [member function]
    cls.add_method('Lookup', 
                   'void *', 
                   [param('void *', 'module'), param('std::string', 'symbol')], 
                   is_pure_virtual=True, is_virtual=True)
    ## loader-factory.h: void ns3::Loader::Unload(void * module) [member function]
    cls.add_method('Unload', 
                   'void', 
                   [param('void *', 'module')], 
                   is_pure_virtual=True, is_virtual=True)
    ## loader-factory.h: void ns3::Loader::UnloadAll() [member function]
    cls.add_method('UnloadAll', 
                   'void', 
                   [], 
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3Task_methods(root_module, cls):
    ## task-manager.h: ns3::Task::Task() [constructor]
    cls.add_constructor([])
    ## task-manager.h: ns3::Task::Task(ns3::Task const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::Task const &', 'arg0')])
    ## task-manager.h: void * ns3::Task::GetContext() const [member function]
    cls.add_method('GetContext', 
                   'void *', 
                   [], 
                   is_const=True)
    ## task-manager.h: void * ns3::Task::GetExtraContext() const [member function]
    cls.add_method('GetExtraContext', 
                   'void *', 
                   [], 
                   is_const=True)
    ## task-manager.h: bool ns3::Task::IsActive() const [member function]
    cls.add_method('IsActive', 
                   'bool', 
                   [], 
                   is_const=True)
    ## task-manager.h: bool ns3::Task::IsBlocked() const [member function]
    cls.add_method('IsBlocked', 
                   'bool', 
                   [], 
                   is_const=True)
    ## task-manager.h: bool ns3::Task::IsDead() const [member function]
    cls.add_method('IsDead', 
                   'bool', 
                   [], 
                   is_const=True)
    ## task-manager.h: bool ns3::Task::IsRunning() const [member function]
    cls.add_method('IsRunning', 
                   'bool', 
                   [], 
                   is_const=True)
    ## task-manager.h: void ns3::Task::SetContext(void * ctx) [member function]
    cls.add_method('SetContext', 
                   'void', 
                   [param('void *', 'ctx')])
    ## task-manager.h: void ns3::Task::SetExtraContext(void * ctx) [member function]
    cls.add_method('SetExtraContext', 
                   'void', 
                   [param('void *', 'ctx')])
    return

def register_Ns3ProcessManager_methods(root_module, cls):
    ## process-manager.h: ns3::ProcessManager::ProcessManager(ns3::ProcessManager const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::ProcessManager const &', 'arg0')])
    ## process-manager.h: ns3::ProcessManager::ProcessManager() [constructor]
    cls.add_constructor([])
    ## process-manager.h: ns3::Thread * ns3::ProcessManager::CreateThread(ns3::Process * process) [member function]
    cls.add_method('CreateThread', 
                   'ns3::Thread *', 
                   [param('ns3::Process *', 'process')])
    ## process-manager.h: void ns3::ProcessManager::DeleteProcess(ns3::Process * process) [member function]
    cls.add_method('DeleteProcess', 
                   'void', 
                   [param('ns3::Process *', 'process')])
    ## process-manager.h: void ns3::ProcessManager::DeleteThread(ns3::Thread * thread) [member function]
    cls.add_method('DeleteThread', 
                   'void', 
                   [param('ns3::Thread *', 'thread')])
    ## process-manager.h: void ns3::ProcessManager::Exit() [member function]
    cls.add_method('Exit', 
                   'void', 
                   [])
    ## process-manager.h: static ns3::TypeId ns3::ProcessManager::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## process-manager.h: ns3::Process * ns3::ProcessManager::SearchProcess(uint16_t pid) const [member function]
    cls.add_method('SearchProcess', 
                   'ns3::Process *', 
                   [param('uint16_t', 'pid')], 
                   is_const=True)
    ## process-manager.h: ns3::Thread * ns3::ProcessManager::SearchThread(uint16_t pid, uint16_t tid) [member function]
    cls.add_method('SearchThread', 
                   'ns3::Thread *', 
                   [param('uint16_t', 'pid'), param('uint16_t', 'tid')])
    ## process-manager.h: void ns3::ProcessManager::SetFinishedCallback(uint16_t pid, ns3::Callback<void,short unsigned int,int,ns3::empty,ns3::empty,ns3::empty,ns3::empty,ns3::empty,ns3::empty,ns3::empty> cb) [member function]
    cls.add_method('SetFinishedCallback', 
                   'void', 
                   [param('uint16_t', 'pid'), param('ns3::Callback< void, short unsigned int, int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty >', 'cb')])
    ## process-manager.h: uint16_t ns3::ProcessManager::Start(std::string name, std::vector<std::string, std::allocator<std::string> > args, std::vector<std::pair<std::string, std::string>, std::allocator<std::pair<std::string, std::string> > > envs) [member function]
    cls.add_method('Start', 
                   'uint16_t', 
                   [param('std::string', 'name'), param('std::vector< std::string >', 'args'), param('std::vector< std::pair< std::string, std::string > >', 'envs')])
    ## process-manager.h: uint16_t ns3::ProcessManager::Start(std::string name, uint32_t stackSize, std::vector<std::string, std::allocator<std::string> > args, std::vector<std::pair<std::string, std::string>, std::allocator<std::pair<std::string, std::string> > > envs) [member function]
    cls.add_method('Start', 
                   'uint16_t', 
                   [param('std::string', 'name'), param('uint32_t', 'stackSize'), param('std::vector< std::string >', 'args'), param('std::vector< std::pair< std::string, std::string > >', 'envs')])
    ## process-manager.h: void ns3::ProcessManager::Stop(uint16_t pid) [member function]
    cls.add_method('Stop', 
                   'void', 
                   [param('uint16_t', 'pid')])
    ## process-manager.h: void ns3::ProcessManager::Wait() [member function]
    cls.add_method('Wait', 
                   'void', 
                   [])
    ## process-manager.h: ns3::Time ns3::ProcessManager::Wait(ns3::Time timeout) [member function]
    cls.add_method('Wait', 
                   'ns3::Time', 
                   [param('ns3::Time', 'timeout')])
    ## process-manager.h: void ns3::ProcessManager::Wakeup(ns3::Thread * thread) [member function]
    cls.add_method('Wakeup', 
                   'void', 
                   [param('ns3::Thread *', 'thread')])
    ## process-manager.h: void ns3::ProcessManager::Yield() [member function]
    cls.add_method('Yield', 
                   'void', 
                   [])
    ## process-manager.h: void ns3::ProcessManager::DoDispose() [member function]
    cls.add_method('DoDispose', 
                   'void', 
                   [], 
                   visibility='private', is_virtual=True)
    return

def register_Ns3SocketFdFactory_methods(root_module, cls):
    ## socket-fd-factory.h: ns3::SocketFdFactory::SocketFdFactory() [constructor]
    cls.add_constructor([])
    ## socket-fd-factory.h: ns3::SocketFdFactory::SocketFdFactory(ns3::SocketFdFactory const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::SocketFdFactory const &', 'arg0')])
    ## socket-fd-factory.h: ns3::UnixFd * ns3::SocketFdFactory::CreateSocket(int domain, int type, int protocol) [member function]
    cls.add_method('CreateSocket', 
                   'ns3::UnixFd *', 
                   [param('int', 'domain'), param('int', 'type'), param('int', 'protocol')], 
                   is_pure_virtual=True, is_virtual=True)
    ## socket-fd-factory.h: static ns3::TypeId ns3::SocketFdFactory::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    return

def register_Ns3TaskManager_methods(root_module, cls):
    ## task-manager.h: ns3::TaskManager::TaskManager(ns3::TaskManager const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::TaskManager const &', 'arg0')])
    ## task-manager.h: ns3::TaskManager::TaskManager() [constructor]
    cls.add_constructor([])
    ## task-manager.h: static ns3::TaskManager * ns3::TaskManager::Current() [member function]
    cls.add_method('Current', 
                   'ns3::TaskManager *', 
                   [], 
                   is_static=True)
    ## task-manager.h: ns3::Task * ns3::TaskManager::CurrentTask() [member function]
    cls.add_method('CurrentTask', 
                   'ns3::Task *', 
                   [])
    ## task-manager.h: void ns3::TaskManager::Exit() [member function]
    cls.add_method('Exit', 
                   'void', 
                   [])
    ## task-manager.h: uint32_t ns3::TaskManager::GetStackSize(ns3::Task * task) const [member function]
    cls.add_method('GetStackSize', 
                   'uint32_t', 
                   [param('ns3::Task *', 'task')], 
                   is_const=True)
    ## task-manager.h: static ns3::TypeId ns3::TaskManager::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## task-manager.h: void ns3::TaskManager::SetScheduler(ns3::Ptr<ns3::TaskScheduler> scheduler) [member function]
    cls.add_method('SetScheduler', 
                   'void', 
                   [param('ns3::Ptr< ns3::TaskScheduler >', 'scheduler')])
    ## task-manager.h: void ns3::TaskManager::SetSwitchNotify(void (*)(  ) * fn) [member function]
    cls.add_method('SetSwitchNotify', 
                   'void', 
                   [param('void ( * ) (  ) *', 'fn')])
    ## task-manager.h: void ns3::TaskManager::Sleep() [member function]
    cls.add_method('Sleep', 
                   'void', 
                   [])
    ## task-manager.h: ns3::Time ns3::TaskManager::Sleep(ns3::Time timeout) [member function]
    cls.add_method('Sleep', 
                   'ns3::Time', 
                   [param('ns3::Time', 'timeout')])
    ## task-manager.h: ns3::Task * ns3::TaskManager::Start(void (*)( void * ) * fn, void * context) [member function]
    cls.add_method('Start', 
                   'ns3::Task *', 
                   [param('void ( * ) ( void * ) *', 'fn'), param('void *', 'context')])
    ## task-manager.h: ns3::Task * ns3::TaskManager::Start(void (*)( void * ) * fn, void * context, uint32_t stackSize) [member function]
    cls.add_method('Start', 
                   'ns3::Task *', 
                   [param('void ( * ) ( void * ) *', 'fn'), param('void *', 'context'), param('uint32_t', 'stackSize')])
    ## task-manager.h: void ns3::TaskManager::Stop(ns3::Task * task) [member function]
    cls.add_method('Stop', 
                   'void', 
                   [param('ns3::Task *', 'task')])
    ## task-manager.h: void ns3::TaskManager::Wakeup(ns3::Task * task) [member function]
    cls.add_method('Wakeup', 
                   'void', 
                   [param('ns3::Task *', 'task')])
    ## task-manager.h: void ns3::TaskManager::Yield() [member function]
    cls.add_method('Yield', 
                   'void', 
                   [])
    return

def register_Ns3TaskScheduler_methods(root_module, cls):
    ## task-scheduler.h: ns3::TaskScheduler::TaskScheduler() [constructor]
    cls.add_constructor([])
    ## task-scheduler.h: ns3::TaskScheduler::TaskScheduler(ns3::TaskScheduler const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::TaskScheduler const &', 'arg0')])
    ## task-scheduler.h: void ns3::TaskScheduler::Dequeue(ns3::Task * task) [member function]
    cls.add_method('Dequeue', 
                   'void', 
                   [param('ns3::Task *', 'task')], 
                   is_pure_virtual=True, is_virtual=True)
    ## task-scheduler.h: void ns3::TaskScheduler::DequeueNext() [member function]
    cls.add_method('DequeueNext', 
                   'void', 
                   [], 
                   is_pure_virtual=True, is_virtual=True)
    ## task-scheduler.h: void ns3::TaskScheduler::Enqueue(ns3::Task * task) [member function]
    cls.add_method('Enqueue', 
                   'void', 
                   [param('ns3::Task *', 'task')], 
                   is_pure_virtual=True, is_virtual=True)
    ## task-scheduler.h: static ns3::TypeId ns3::TaskScheduler::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    ## task-scheduler.h: ns3::Task * ns3::TaskScheduler::PeekNext() [member function]
    cls.add_method('PeekNext', 
                   'ns3::Task *', 
                   [], 
                   is_pure_virtual=True, is_virtual=True)
    return

def register_Ns3LoaderFactory_methods(root_module, cls):
    ## loader-factory.h: ns3::LoaderFactory::LoaderFactory() [constructor]
    cls.add_constructor([])
    ## loader-factory.h: ns3::LoaderFactory::LoaderFactory(ns3::LoaderFactory const & arg0) [copy constructor]
    cls.add_constructor([param('ns3::LoaderFactory const &', 'arg0')])
    ## loader-factory.h: ns3::Loader * ns3::LoaderFactory::Create(int argc, char * * argv, char * * envp) [member function]
    cls.add_method('Create', 
                   'ns3::Loader *', 
                   [param('int', 'argc'), param('char * *', 'argv'), param('char * *', 'envp')], 
                   is_pure_virtual=True, is_virtual=True)
    ## loader-factory.h: static ns3::TypeId ns3::LoaderFactory::GetTypeId() [member function]
    cls.add_method('GetTypeId', 
                   'ns3::TypeId', 
                   [], 
                   is_static=True)
    return

def register_functions(root_module):
    module = root_module
    ## utils.h: extern ns3::Thread * ns3::Current() [free function]
    module.add_function('Current', 
                        'ns3::Thread *', 
                        [])
    ## utils.h: extern bool ns3::HasPendingSignal() [free function]
    module.add_function('HasPendingSignal', 
                        'bool', 
                        [])
    ## utils.h: extern int ns3::UtilsAllocateFd() [free function]
    module.add_function('UtilsAllocateFd', 
                        'int', 
                        [])
    ## utils.h: extern void ns3::UtilsDoSignal() [free function]
    module.add_function('UtilsDoSignal', 
                        'void', 
                        [])
    ## utils.h: extern std::string ns3::UtilsGetNodeFilePath() [free function]
    module.add_function('UtilsGetNodeFilePath', 
                        'std::string', 
                        [])
    ## utils.h: extern uint32_t ns3::UtilsGetNodeId() [free function]
    module.add_function('UtilsGetNodeId', 
                        'uint32_t', 
                        [])
    ## utils.h: extern std::string ns3::UtilsGetRealFilePath(std::string path) [free function]
    module.add_function('UtilsGetRealFilePath', 
                        'std::string', 
                        [param('std::string', 'path')])
    ## utils.h: extern std::string ns3::UtilsGetVirtualFilePath(std::string path) [free function]
    module.add_function('UtilsGetVirtualFilePath', 
                        'std::string', 
                        [param('std::string', 'path')])
    ## utils.h: extern int ns3::UtilsSearchOpenFd(int fd) [free function]
    module.add_function('UtilsSearchOpenFd', 
                        'int', 
                        [param('int', 'fd')])
    ## utils.h: extern void ns3::UtilsSendSignal(ns3::Process * process, int signum) [free function]
    module.add_function('UtilsSendSignal', 
                        'void', 
                        [param('ns3::Process *', 'process'), param('int', 'signum')])
    ## utils.h: extern ns3::Time ns3::UtilsSimulationTimeToTime(ns3::Time time) [free function]
    module.add_function('UtilsSimulationTimeToTime', 
                        'ns3::Time', 
                        [param('ns3::Time', 'time')])
    ## utils.h: extern ns3::Time ns3::UtilsTimeToSimulationTime(ns3::Time time) [free function]
    module.add_function('UtilsTimeToSimulationTime', 
                        'ns3::Time', 
                        [param('ns3::Time', 'time')])
    ## utils.h: extern timespec ns3::UtilsTimeToTimespec(ns3::Time time) [free function]
    module.add_function('UtilsTimeToTimespec', 
                        'timespec', 
                        [param('ns3::Time', 'time')])
    ## utils.h: extern timeval ns3::UtilsTimeToTimeval(ns3::Time time) [free function]
    module.add_function('UtilsTimeToTimeval', 
                        'timeval', 
                        [param('ns3::Time', 'time')])
    ## utils.h: extern ns3::Time ns3::UtilsTimespecToTime(timespec tm) [free function]
    module.add_function('UtilsTimespecToTime', 
                        'ns3::Time', 
                        [param('timespec', 'tm')])
    ## utils.h: extern ns3::Time ns3::UtilsTimevalToTime(timeval tv) [free function]
    module.add_function('UtilsTimevalToTime', 
                        'ns3::Time', 
                        [param('timeval', 'tv')])
    ## utils.h: extern ns3::Time ns3::UtilsTimevalToTime(timeval const * tv) [free function]
    module.add_function('UtilsTimevalToTime', 
                        'ns3::Time', 
                        [param('timeval const *', 'tv')])
    register_functions_ns3_Config(module.get_submodule('Config'), root_module)
    register_functions_ns3_TimeStepPrecision(module.get_submodule('TimeStepPrecision'), root_module)
    register_functions_ns3_addressUtils(module.get_submodule('addressUtils'), root_module)
    register_functions_ns3_aodv(module.get_submodule('aodv'), root_module)
    register_functions_ns3_dot11s(module.get_submodule('dot11s'), root_module)
    register_functions_ns3_flame(module.get_submodule('flame'), root_module)
    register_functions_ns3_internal(module.get_submodule('internal'), root_module)
    register_functions_ns3_olsr(module.get_submodule('olsr'), root_module)
    return

def register_functions_ns3_Config(module, root_module):
    return

def register_functions_ns3_TimeStepPrecision(module, root_module):
    return

def register_functions_ns3_addressUtils(module, root_module):
    return

def register_functions_ns3_aodv(module, root_module):
    return

def register_functions_ns3_dot11s(module, root_module):
    return

def register_functions_ns3_flame(module, root_module):
    return

def register_functions_ns3_internal(module, root_module):
    return

def register_functions_ns3_olsr(module, root_module):
    return

