#!/usr/bin/env python

import benchmark
import re

var1 = [
    '1Mbps',
    '2Mbps',
    '4Mbps',
    '8Mbps',
    '16Mbps',
    '32Mbps',
    '64Mbps',
    '128Mbps',
    '256Mbps',
    '512Mbps',
    '1024Mbps',
]
var1Name = '--Bandwidth='

var2 = [
    '1',
    '2',
    '4',
    '8',
    '16',
    '32',
    '64',
    '128',
    '254',
]
var2Name = '--nHops='

var3 = [
    '50',
    '500',
    '1000',
    '1300',
]
var3Name = '--ns3::TcpSocket::SegmentSize='

class StdoutParser:
    def __init__(self):
        self.bandwidth = ''
        self.bytes = 0
    def parse(self, output):
        self.bytes = 0
        self.bandwidth = ''
        reg = re.compile('([^,]+),([^,\n]+)$')
        for line in (output[0]).split ('\n'):
            match = reg.search (line)
            if match is not None:
                self.bytes += int (match.group(1))
                self.bandwidth = match.group(2)

def bench(args, handler):
    result = benchmark.bench(args, handleOutput=handler)
    return result.min_time
    #import subprocess
    #proc = subprocess.Popen(args,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
    #result = proc.communicate()
    #handler(result)
    #return 0

print var1Name + ',' + var2Name + ',' + \
    'bandwidth(bps),total bytes,runtime(s)' + ',' + var3Name
import sys
arg3 = sys.argv[1]
print arg3
for arg1 in var1:
    for arg2 in var2:
        args = ['build/optimized/examples/process/process-iperf', 
                var1Name + arg1, var2Name + arg2, var3Name + arg3]
        stdout = StdoutParser ()
        result = bench(args, stdout.parse)
        print arg1 + ',' + arg2 + ',' + stdout.bandwidth + ',' + str(stdout.bytes) + ',' + str (result) + ',' + arg3
