#ifndef ELF_FILE_WRITER_H
#define ELF_FILE_WRITER_H

#include "file-writer.h"
#include "elf-types.h"

namespace ns3 {

class ElfFileWriter
{
public:
  ElfFileWriter (std::string filename);

  uint64_t GetOffset (void);
  void WriteHeader (struct mdbg::ElfHeader header);
  void WriteSectionHeader (struct mdbg::ElfSectionHeader header);
  void Seek (uint64_t offset);
  void Skip (int64_t offset);
  void WriteU8 (uint8_t v);
  void Write (uint8_t *buffer, uint64_t size);
  void WriteHalf (mdbg::ElfHalf v);
  void WriteXword (mdbg::ElfXword v);
  void WriteSxword (mdbg::ElfSxword v);
  void WriteWord (mdbg::ElfWord v);
  void WriteSword (mdbg::ElfSword v);
  void WriteOff (mdbg::ElfOff v);
  void WriteAddr (mdbg::ElfAddr v);
  void WriteString (std::string str);

private:
  FileWriter m_writer;
  bool m_64;
};

} // namespace ns3

#endif /* ELF_FILE_WRITER_H */
