#ifndef ELF_TYPES_H
#define ELF_TYPES_H

#define SHT_NULL 0
#define SHT_DYNAMIC 6
#define SHT_GNU_verdef 0x6ffffffd
#define SHT_GNU_verneed 0x6ffffffe
#define SHT_GNU_versym 0x6fffffff
#define PT_LOAD 1
#define DT_NULL 0
#define DT_NEEDED 1
#define DT_STRTAB 5
#define DT_SONAME 14
#define DT_GNU_PRELINKED 0x6ffffdf5
#define DT_VERSYM 0x6ffffff0
#define	DT_VERDEF 0x6ffffffc
#define	DT_VERDEFNUM 0x6ffffffd
#define	DT_VERNEED 0x6ffffffe
#define	DT_VERNEEDNUM 0x6fffffff


namespace mdbg {

typedef uint16_t ElfHalf;
typedef uint64_t ElfAddr;
typedef uint64_t ElfOff;
typedef uint32_t ElfWord;
typedef int32_t  ElfSword;
typedef uint64_t ElfXword;
typedef int64_t  ElfSxword;

struct ElfHeader
{
  uint8_t ei_class;
  uint8_t ei_data;
  uint8_t ei_version;
  ElfHalf e_type;
  ElfHalf e_machine;
  ElfWord e_version;
  ElfAddr e_entry;
  ElfOff  e_phoff;
  ElfOff  e_shoff;
  ElfWord e_flags;
  ElfHalf e_ehsize;
  ElfHalf e_phentsize;
  ElfHalf e_phnum;
  ElfHalf e_shentsize;
  ElfHalf e_shnum;
  ElfHalf e_shstrndx;
};

struct ElfSectionHeader
{
  ElfWord  sh_name;
  ElfWord  sh_type;
  ElfXword sh_flags;
  ElfAddr  sh_addr;
  ElfOff   sh_offset;
  ElfXword sh_size;
  ElfWord  sh_link;
  ElfWord  sh_info;
  ElfXword sh_addralign;
  ElfXword sh_entsize;
};

struct ElfProgramHeader
{
  ElfWord  p_type;
  ElfWord  p_flags;
  ElfOff   p_offset;
  ElfAddr  p_vaddr;
  ElfAddr  p_paddr;
  ElfXword p_filesz;
  ElfXword p_memsz;
  ElfXword p_align;
};

} // namespace mdbg

#endif /* ELF_TYPES_H */
