#ifndef FILE_WRITER_H
#define FILE_WRITER_H

#include <stdint.h>
#include <string>

namespace ns3 {

class FileWriter
{
public:
  FileWriter (std::string filename);
  ~FileWriter ();

  bool IsOk (void) const;
  void SetFail (void);

  uint64_t GetOffset (void);
  void SetLsb (void);
  void SetMsb (void);
  void Seek (uint64_t offset);
  void Skip (int64_t offset);
  void WriteU8  (uint8_t v);
  void WriteU16 (uint16_t v);
  void WriteU32 (uint32_t v);
  void WriteU64 (uint64_t v);
  void Write (uint8_t *buffer, uint64_t size);
private:
  int m_fd;
  bool m_lsb;
  bool m_ok;
};

} // namespace ns3

#endif /* FILE_WRITER_H */
