#ifndef MMAPED_FILE_H
#define MMAPED_FILE_H

#include <string>
#include <stdint.h>

namespace mdbg {

class MmapedFile
{
public:
  MmapedFile (std::string filename);
  ~MmapedFile ();

  bool IsOk (void) const;
  uint64_t GetSize (void) const;
  uint8_t *GetBuffer (void) const;

private:
  // copying illegal.
  MmapedFile &operator = (const MmapedFile &o);
  MmapedFile (const MmapedFile &o);
  int m_fd;
  uint64_t m_size;
  uint8_t *m_buffer;
  bool m_ok;
};

} // namespace mdbg

#endif /* MMAPED_FILE_H */
