#ifndef ELF_LOADER_H
#define ELF_LOADER_H

#include <string>
#include <vector>
#include "libc.h"
#include "libc-globals.h"

namespace ns3 {

class ElfLoader
{
public:
  virtual ~ElfLoader ();

  virtual void UnloadAll (void) = 0;

  virtual int LoadAndStartMain (const char *filename,
				char **argv, int argc, char **envp, 
				const struct Libc *libc) = 0;
  
  virtual void *Lookup (std::string symbol) = 0;  
};

} // namespace ns3

#endif /* ELF_LOADER_H */
